<?php
/* ************************************************************
Copyright (C) 2008 - 2009 by Xander Groesbeek (CompactCMS.nl)
Revision:	CompactCMS - v 1.4.0
	
This file is part of CompactCMS.

CompactCMS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CompactCMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A reference to the original author of CompactCMS and its copyright
should be clearly visible AT ALL TIMES for the user of the back-
end. You are NOT allowed to remove any references to the original
author, communicating the product to be your own, without written
permission of the original copyright owner.

You should have received a copy of the GNU General Public License
along with CompactCMS. If not, see <http://www.gnu.org/licenses/>.
	
> Contact me for any inquiries.
> E: Xander@CompactCMS.nl
> W: http://www.CompactCMS.nl/forum
************************************************************ */

// Authorization required message
$authreq = "Not in session. Authorization required. <a href=\"?login\">Login again</a>.";

// Do not modify any of the lines below.
if ($cfg['protect']===true) {
	
	function http_digest_parse($txt) {
		// protect against missing data
		$needed_parts = array('nonce'=>1, 'nc'=>1, 'cnonce'=>1, 'qop'=>1, 'username'=>1, 'uri'=>1, 'response'=>1);
		$data = array();
	
		preg_match_all('@(\w+)=(?:(?:\'([^\']+)\'|"([^"]+)")|([^\s,]+))@', $txt, $matches, PREG_SET_ORDER);
	
		foreach ($matches as $m) {
			$data[$m[1]] = $m[3] ? $m[3] : $m[4];
			unset($needed_parts[$m[1]]);
		}
		return $needed_parts ? false : $data;
	}
	
	$realm = 'CompactCMS Administration';
	$users = array($cfg['user'] => $cfg['pass']);
	
	function sentDigest($realm,$uniqid) {
		global $authreq;
		header('HTTP/1.1 401 Unauthorized');
		header('WWW-Authenticate: Digest realm="'.$realm.'",qop="auth",nonce="'.$uniqid.'",opaque="'.md5($realm).'"');
		die("$authreq");
	}
	
	$uniqid = uniqid("");
	if (empty($_SERVER['PHP_AUTH_DIGEST'])) {
		header('HTTP/1.1 401 Unauthorized');
	    header('WWW-Authenticate: Digest realm="'.$realm.'",qop="auth",nonce="'.$uniqid.'",opaque="'.md5($realm).'"');
	    die("$authreq");
	}

	// Analyze the PHP_AUTH_DIGEST variable
	if (!($data = http_digest_parse($_SERVER['PHP_AUTH_DIGEST'])) || !isset($users[$data['username']])) {
		sentDigest($realm,$uniqid);
	}
	
	// Generate the valid response
	$A1 = md5($data['username'] . ':' . $realm . ':' . $users[$data['username']]);
	$A2 = md5($_SERVER['REQUEST_METHOD'].':'.$data['uri']);
	$valid_response = md5($A1.':'.$data['nonce'].':'.$data['nc'].':'.$data['cnonce'].':'.$data['qop'].':'.$A2);
	
	if ($data['response'] != $valid_response) {
		sentDigest($realm,$uniqid);
	}
	
	// Set variable if okay
	$_SESSION['ccms']['username'] 	= $data['username'];
	$_SESSION['ccms']['host']		= md5($_SERVER['HTTP_HOST']);
	
	if(empty($_SESSION['ccms'])) {
		sentDigest($realm,$uniqid);
	}
	
	if(isset($_GET['logout'])) {
		unset($_SESSION['ccms']);
		$data['response'] = rand('123456','987654');
		sentDigest($realm,$uniqid);
		exit();
	}
}
?>