/* ************************************************************
Copyright (C) 2008 - 2009 by Xander Groesbeek (CompactCMS.nl)
Revision:	CompactCMS - v 1.4.0
	
This file is part of CompactCMS.

CompactCMS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CompactCMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A reference to the original author of CompactCMS and its copyright
should be clearly visible AT ALL TIMES for the user of the back-
end. You are NOT allowed to remove any references to the original
author, communicating the product to be your own, without written
permission of the original copyright owner.

You should have received a copy of the GNU General Public License
along with CompactCMS. If not, see <http://www.gnu.org/licenses/>.
	
> Contact me for any inquiries.
> E: Xander@CompactCMS.nl
> W: http://www.CompactCMS.nl/forum
************************************************************ */

window.addEvent('domready', function(){
	
	function editin_init() {
		$$('.liveedit').each(function(el) {
			
			el.addEvent('click',function() {
				el.set('class','liveedit2');
				var before = el.get('html').trim();
				el.set('html','');
				
				var input = new Element('textarea', { 'wrap':'soft', 'class':'textarea', 'text':before });
				
				input.addEvent('click', function (e) {
				e.stop();
					return;
				});
				
				input.addEvent('keydown', function(e) { if(e.key == 'enter') { this.fireEvent('blur'); } });
				input.inject(el).select();
				
				//add blur event to input
				input.addEvent('blur', function() {
					//get value, place it in original element
					val = input.get('value').trim();
					el.set('text',val);
					
					//save respective record
					var content = el.get('text');
					var request = new Request.HTML({
						url:'./index.php?part='+el.get('rel'),
						method:'post',
						update: el,
						data: 'action=liveedit&id='+el.get('id')+'&content='+content,
						onRequest: function() {
							el.set("html","<img src='img/saving.gif' alt='Saving' />");
						},
						onComplete: function() {
							el.set("class","sprite-hover liveedit");
						}
					}).send();
				});
			});
		});
	}
	
	// Show list onload
	var dyn_list = $('dyn_list').empty().addClass('loading');

	var req = new Request.HTML({
		method: 'get',
		url: './index.php?action=update',
		update: dyn_list,
		onComplete: function() {
			dyn_list.removeClass('loading');
			editin_init();
			editPlace();
			externalLinks();
		}
	}).send();
 
	// Dynamic list on request
	$$('a.update').addEvent('click', function(update) {
		new Event(update).stop();
			
		var dyn_list = $('dyn_list').empty().addClass('loading');
		var notify = $('notify_res').empty();
		var status = $('notify').addClass('loading');
		
		notify.setStyle('border', 'none');
		
		new Request.HTML({
			method: 'get',
			url: './index.php?action=update',
			update: dyn_list,
			onComplete: function() {
				editin_init();
				editPlace();
				externalLinks();
				dyn_list.removeClass('loading');
				status.removeClass('loading');
			}
		}).send();
	});	
	
	// Render menu depth list
	function renderList() {
		var menudepth = $('menuFields').addClass('loading');
		
		new Request.HTML({
			method: 'get',
			url: './index.php?action=renderlist',
			update: menudepth,
			onComplete: function() {
				menudepth.removeClass('loading');
				isLink();
			}
		}).send();
	}

	// Refresh on print/publish update
	function refreshContent() {
		var dyn_list = $('dyn_list').empty().addClass('loading');
		var notify = $('notify_res');
		var status = $('notify').addClass('loading');
		
		notify.setStyle('border', 'none');
		
		new Request.HTML({
			method: 'get',
			url: './index.php?action=update',
			update: dyn_list,
			onComplete: function() {
				editin_init();
				editPlace();
				externalLinks();
				renderList();
				dyn_list.removeClass('loading');
				status.removeClass('loading');
			}
		}).send();
	}
	
	// Process new page
	$('addForm').addEvent('submit', function(add) {
		new Event(add).stop();
		
		// Setting waiting style 
		var notify = $('notify_res').empty();
		var status = $('notify').addClass('loading');
		closeMenu();
		
		// Wait for response and act
		new Request.HTML({
			method: 'post',
			url: './index.php',
			update: notify,
			onComplete: function() {
				status.removeClass('loading');
				refreshContent();
				renderList();
			}
		}).post($('addForm'));
	});

	// Process delete page
	$('delete').addEvent('submit', function(remove) {
		var agree = confirm($('ad_msg01').value);
		
		if(agree) {
			closeMenu();
			new Event(remove).stop();
			
			//var url = this.href;
			var notify = $('notify_res').empty();
			var status = $('notify').addClass('loading');
			
			// Wait for response and act
			new Request.HTML({
				method: 'post',
				url: './index.php',
				update: notify,
				onComplete: function() {
					status.removeClass('loading');
					refreshContent();
					renderList();
				}
			}).post($('delete'));
		} else {
			new Event(remove).stop();
		}
	});
	
	// Process menu order preference
	$('menuForm').addEvent('submit', function(menu) {
		new Event(menu).stop();
		
		// Setting waiting style 
		var notify = $('notify_res').empty();
		var status = $('notify').addClass('loading');
		
		// Wait for response and act
		new Request.HTML({
			url: './index.php',
			method: 'post',
			update: notify,
			onComplete: function() {
				status.removeClass('loading');
				refreshContent();
			}
		}).post($('menuForm'));
	});
	
	// Change linkage preference
	function isLink() {
	$$('.islink').addEvent('click', function(islink) {  
        var item_id	= this.id;
        var cvalue	= this.checked;
        var status	= $('notify').addClass('loading');
        var islink	= $('td-islink-'+item_id).addClass('printloading');
		
        new Request({
            url:'index.php',
            method:'post',
            autoCancel:true,
            data:'cvalue=' + cvalue + '&action=islink&id='+item_id,
            onSuccess: function() {
				status.removeClass('loading');
				islink.removeClass('printloading');
            },
            onFailure: function() {
				$('notify').set('text','Undocumented error!');
			}
        }).send();
    });
	}
	
	// Change print or publish value
	function editPlace() {
	$$('.editinplace').addEvent('click', function(editinplace) {
		new Event(editinplace).stop();
		closeMenu();
		
		var url = './index.php?action=editinplace&id='+this.id+'&s='+this.rel;	
		var status = $(this.id).addClass('printloading');
		
		new Request.HTML({
			method: 'get',
			url: url,
			update: status,
			onComplete: function() {
				status.removeClass('printloading');
				refreshContent();
			}
		}).send();
	});	
	}
	
	// Collapsible - add page
	var myAdd = new Fx.Slide('form_wrapper');
	myAdd.toggle();
	 
	$('toggle-1').addEvent('click', function(e){
		e = new Event(e);
		myAdd.toggle();
		e.stop();
	});
	
	// Collapsible - menu depth
	var myMenu = new Fx.Slide('menu_wrapper');
	renderList();
	myMenu.toggle();
		 
	$('toggle-3').addEvent('click', function(e){
		e = new Event(e);
		myMenu.toggle();
		e.stop();
	});
	
	// Close only (menuDepth)
	function closeMenu() {
		var menuClose = new Fx.Slide('menu_wrapper');
		menuClose.slideOut();
	}
	
	// Tips links
	$$('span.hints').each(function(element,index) {  
		var content = element.get('title').split('::');  
		element.store('tip:title', content[0]);  
		element.store('tip:text', content[1]);  
	});  
  
	// Create the tooltips  
	var tipz = new Tips('.hints',{  
		className: 'hints',  
		fixed: true,  
		hideDelay: 50,  
		showDelay: 50  
	}); 
});

// External links script (rel=external)
function externalLinks() {
	if (!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	
	for (var i=0; i<anchors.length; i++) {
   	var anchor = anchors[i];
		if (anchor.getAttribute("href") &&
			anchor.getAttribute("class") == "external")
			anchor.target = "_blank";
	}
}
window.onload = externalLinks;