<?php
/* ************************************************************
Copyright (C) 2008 - 2009 by Xander Groesbeek (CompactCMS.nl)
Revision:	CompactCMS - v 1.4.0
	
This file is part of CompactCMS.

CompactCMS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CompactCMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A reference to the original author of CompactCMS and its copyright
should be clearly visible AT ALL TIMES for the user of the back-
end. You are NOT allowed to remove any references to the original
author, communicating the product to be your own, without written
permission of the original copyright owner.

You should have received a copy of the GNU General Public License
along with CompactCMS. If not, see <http://www.gnu.org/licenses/>.
	
> Contact me for any inquiries.
> E: Xander@CompactCMS.nl
> W: http://community.CompactCMS.nl/forum
************************************************************ */

/*
  MySQL database backup class, version 1.0.0
  Written by Rochak Chauhan
  Released under GNU Public license
*/

// Include general configuration
require_once('../../sitemap.php');

$canarycage	= md5(session_id());
$currenthost= md5($_SERVER['HTTP_HOST']);

if($_GET['do']=="backup" && $_POST['btn_backup']=="dobackup" && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
	
	// Include back-up functions
	include_once('functions.php');
	
	$configBackup 		= array('../../../content/','../../templates/');
	$configBackupDir 	= 'files/';
	$backupName 		= "backup-".date('d-m-y H-i-s').'.zip';
	
	$createZip = new createZip;
	if (isset($configBackup) && is_array($configBackup) && count($configBackup)>0) {
	    foreach ($configBackup as $dir) {
	        $basename = basename($dir);
	        if (is_file($dir)) {
	            $fileContents = file_get_contents($dir);
	            $createZip->addFile($fileContents,$basename);
	        } else {
	            $createZip->addDirectory($basename."/");
	            $files = directoryToArray($dir,true);
	            $files = array_reverse($files);
	
	            foreach ($files as $file) {
	                $zipPath = explode($dir,$file);
	                $zipPath = $zipPath[1];
	                if (is_dir($file)) {
	                    $createZip->addDirectory($basename."/".$zipPath);
	                } else {
	                    $fileContents = file_get_contents($file);
	                    $createZip->addFile($fileContents,$basename."/".$zipPath);
	                }
	            }
	        }
	    }
	}
	
	$backup = new MySQL_Backup(); 
	$backup->server   = $cfg['db_host'];
	$backup->username = $cfg['db_user'];
	$backup->password = $cfg['db_pass'];
	$backup->database = $cfg['db_name'];
	$backup->tables   = array('pages');
	
	$backup->backup_dir = $configBackupDir;
	$sqldump = $backup->Execute(MSB_STRING,"",false);
	$createZip->addFile($sqldump,$cfg['db_name'].'-sqldump.sql');
	
	$fileName	= $configBackupDir.$backupName;
	$fd			= fopen ($fileName, "wb");
	$out		= fwrite ($fd, $createZip -> getZippedfile());
	fclose ($fd);
}
?>
<?php if(md5(session_id())==$canarycage && isset($_SESSION['rc1']) && !empty($_SESSION['rc2']) && md5($_SERVER['HTTP_HOST']) == $currenthost) { ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
	<head>
		<meta http-equiv="Content-type" content="text/html; charset=utf-8" />
		<title>backend</title>
		<link rel="stylesheet" type="text/css" href="../../../admin/img/styles/base.css,layout.css,editor.css" />
		<script type="text/javascript">
			<!--
			function confirmation() {
				try {
					parent.window.hs.getExpander('backup_restore').close();
				} catch (e) {}
			}
			//-->
		</script>
	</head>
<body>
	<p class="right"><img src="./logo.png" alt="Official module by CompactCMS.nl"/></p>
	<?php if(!empty($backupName)) { 
		echo "<p class=\"success\">".$ccms['lang']['backend']['newfilecreated'].", <a href=\"./files/$backupName\">".strtolower($ccms['lang']['backup']['download'])."</a>.</p>"; 
	} 
	if($_GET['do']=="delete" && !empty($_POST['file']) && $_POST['btn_delete']=="dodelete" && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
		echo "<div class=\"notice\">";
		foreach ($_POST['file'] as $key => $value) {
			unlink('./files/'.$value);
			echo ucfirst($value)." ".$ccms['lang']['backend']['statusremoved'].".<br/>";
		}
		echo "</div>";
	} elseif($_GET['do']=="delete" && empty($_POST['file']) && $_POST['btn_delete']=="dodelete" && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
		echo "<div class=\"fault\">".$ccms['lang']['system']['error_selection']."</div>";
	} ?>

	<div class="span-7 colborder">
	<h2><?php echo $ccms['lang']['backup']['createhd']; ?></h2>
		<p><?php echo $ccms['lang']['backup']['explain'];?></p>
		<form action="<?php echo $_SERVER['PHP_SELF'];?>?do=backup" method="post" accept-charset="utf-8">
			<p class="right"><button type="submit" name="btn_backup" value="dobackup"><?php echo $ccms['lang']['forms']['createbutton'];?></button></p>
		</form>
	</div>
	
	<div class="span-11 last">
	<h2><?php echo $ccms['lang']['backup']['currenthd'];?></h2>
		<form action="<?php echo $_SERVER['PHP_SELF'];?>?do=delete" method="post" accept-charset="utf-8">
			<table border="0" cellspacing="5" cellpadding="5">
				<tr>
					<th class="span-1">&#160;</th>
					<th class="span-4"><?php echo $ccms['lang']['backup']['timestamp'];?></th>
					<th>&#160;</th>
				</tr>
				<?php 
				if ($handle = opendir('./files/')) {
					$i=0;
					while (false !== ($file = readdir($handle))) {
				        if ($file != "." && $file != ".." && strpos($file, ".zip")) {
				        	$timestamp	= explode('-',$file);
					        $isEven 	= !($i % 2);
					        echo ($isEven!='1')?'<tr>':'<tr style="background-color: #E6F2D9;">';
					        echo '<td><input type="checkbox" name="file[]" value="'.$file.'" id="'.$i.'"></td>';
					        echo '<td>'.$timestamp['1'].'/'.$timestamp['2'].'/20'.$timestamp['3'].':'.$timestamp['4'].'</td>';
					        echo '<td><a href="./files/'.$file.'" title="'.ucfirst($file).'">'.$ccms['lang']['backup']['download'].'</a></td>';
					        echo '</tr>';
				        } 
				    $i++; }
				    closedir($handle);
				}
				?>
			</table>
		<p><br/><button type="submit" name="btn_delete" value="dodelete"><?php echo $ccms['lang']['backend']['delete'];?></button></p>
		</form>
	</div>
		
</body>
</html>
<?php } else die("No external access to file");?>