<?php
/* ************************************************************
Copyright (C) 2008 - 2009 by Xander Groesbeek (CompactCMS.nl)
Revision:	CompactCMS - v 1.4.0
	
This file is part of CompactCMS.

CompactCMS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CompactCMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A reference to the original author of CompactCMS and its copyright
should be clearly visible AT ALL TIMES for the user of the back-
end. You are NOT allowed to remove any references to the original
author, communicating the product to be your own, without written
permission of the original copyright owner.

You should have received a copy of the GNU General Public License
along with CompactCMS. If not, see <http://www.gnu.org/licenses/>.
	
> Contact me for any inquiries.
> E: Xander@CompactCMS.nl
> W: http://community.CompactCMS.nl/forum
************************************************************ */

// The following is required to get around caching issues
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); 
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// Include general configuration
require_once('../../sitemap.php');

$canarycage	= md5(session_id());
$currenthost= md5($_SERVER['HTTP_HOST']);
$name 		= htmlentities($_GET['file']);
$filename	= "../../../content/".htmlentities($_GET['file']).".php";

// Check current database connection
if (!$link && !is_resource($link)) {
	die($ccms['lang']['system']['error_database']);
}

function file_list($d){
   foreach(array_diff(scandir($d),array('.','..','.svn')) as $f)if(is_file($d.'/'.$f))$l[]=$f;
   return $l;
} 

function cleanname($f){
	// Remove all none system friendly characters
	$special_chars = array ("#","$","%","@","^","&","*","!","~","�","\"","�","'","=","?","/","[","]","(",")","|","<",">",";","\\",",");
	
	// Filter spaces, non-file characters and account for UTF-8
	$f = @htmlentities($f,ENT_COMPAT,'UTF-8');
  	$f = str_replace($special_chars, "", $f); 
	$f = str_replace(' ','-',$f);
	$f = strtolower($f);
	
	// Return safe filename
	return $f;
}

// Get albums
$album_location	= "../../../".$cfg['img_path']."/albums/";

if($handle = @opendir($album_location)) {
	while (false !== ($file = readdir($handle))) {
    	if ($file != "." && $file != ".." && $file != ".svn") {
    		$albums[] = $file;
    	}
	} closedir($handle);
} else die($ccms['lang']['system']['error_general']."!<br/><em>".$ccms['lang']['album']['nodir']." <strong>".$cfg['img_path']."</strong></em>.");

$message=null;

// Create new album
if($_GET['do']=="newalbum" && strlen($_POST['album_name'])>3 && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
	
	$album = cleanname($_POST['album_name']);
	if(@mkdir("$album_location/$album", 0755)) {
		$message = "<div class=\"success\"><strong>".ucfirst($album)."</strong> ".$ccms['lang']['album']['newdircreated']."</div>";
		header("Location: backend.php?message=$message&file=$name");
		exit();
	} else $message = "<div class=\"fault\">".$ccms['lang']['system']['error_general']."</div>";	
} elseif($_GET['do']=="newalbum" && strlen($_POST['album_name'])<=3) {
	$message = "<div class=\"fault\">".$ccms['lang']['album']['errordir']."</div>";
}

// Edit album name
if($_GET['do']=="editalbum" && strlen($_POST['newname'])>3 && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
	
	$oldalbum = cleanname($_POST['oldname']);
	$newalbum = cleanname($_POST['newname']);
	if(@rename("$album_location/$oldalbum", "$album_location/$newalbum")) {
		$message = "<div class=\"success\">".$ccms['lang']['album']['album']." <strong>$oldalbum</strong> ".$ccms['lang']['album']['renamed']."  <strong>$newalbum</strong>.</div>";
		header("Location: backend.php?message=$message&file=$name");
		exit();
	} else $message = "<div class=\"fault\">".$ccms['lang']['system']['error_value']."</div>";
} elseif($_GET['do']=="editalbum" && strlen($_POST['newname'])<=3) { 
	$message = "<div class=\"fault\">".$ccms['lang']['album']['errordir']."</div>";
}

// Delete album(s) contents
if($_GET['do']=="delalbum" && !empty($_POST['albumname']) && md5(session_id())==$canarycage && isset($_SESSION['rc1']) && md5($_SERVER['HTTP_HOST'])==$currenthost) {
	
	function delalbum($dir, $deldir=true){
	$dir = htmlentities($dir);
	if(!$dh = @opendir($dir)) return;
	while (false!==($obj=readdir($dh))) {
		if($obj == '.' || $obj == '..') continue;
		if(!@unlink($dir . '/' . $obj )) delalbum($dir.'/'.$obj,true);
	}
	closedir($dh);
	
	if($deldir){
		@rmdir($dir);
		return $dir;
		return true;
	}
}
	if(delalbum($album_location.'/'.$_POST['albumname'], true)) {
		$message = "<div class=\"success\">".$ccms['lang']['album']['album']." <strong>".htmlentities($_POST['albumname'])."</strong> ".$ccms['lang']['album']['removed']."<br/></div>";
		header("Location: backend.php?message=$message&file=$name");
		exit();
	} else $message = "<div class=\"fault\">".$ccms['lang']['system']['error_delete']." (<strong>$album</strong>).<br/></div>";
}
?>
<?php if(md5(session_id())==$canarycage && isset($_SESSION['rc1']) && !empty($_SESSION['rc2']) && md5($_SERVER['HTTP_HOST']) == $currenthost) { ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
	<head>
		<meta http-equiv="Content-type" content="text/html; charset=utf-8" />
		<title>backend</title>
		<link rel="stylesheet" type="text/css" href="../../../admin/img/styles/base.css,layout.css,editor.css" />
		<script language="javascript" type="text/javascript" src="../../../admin/includes/tiny_mce/plugins/tinybrowser/tb_standalone.js.php"></script>
		<script type="text/javascript">
		<!--
		function confirmation(formname) {
		var answer = confirm("<?php echo $ccms['lang']['backend']['confirmdelete'];?>");
			if(answer){
				document.forms[formname].submit(); 
			} else{
				return false;
			}
		}
		//-->
		</script>
	</head>
	<body>
		<p class="right"><span style="margin-right:27%;"><a href="backend.php?file=<?php echo $name;?>"><?php echo $ccms['lang']['album']['refresh']; ?></a> | <a href="../../../<?php echo $_GET['file'].".html";?>" class="external" target="_blank"><?php echo $ccms['lang']['backend']['previewpage']; ?></a></span><img src="./logo.png" alt="Official module by CompactCMS.nl"/></p>
		<? if($message!==null||$_GET['message']!==null){echo $message.$_GET['message'];}?>
		<div class="span-10 colborder">
		<h2><?php echo $ccms['lang']['album']['manage'];?></h2>
		<?php
		if(!empty($albums)) {
			foreach ($albums as $i => $file) { ?>
			    <div class="span-3 albumbox <?php echo ($i%4==0)?'clear':null;?>">
			        <a href="#" onclick="javascript:tinyBrowserPopUp('image','image_<?php echo $i;?>','albums/<?php echo $file;?>');">
			        
			        <?php $image = file_list($album_location.'/'.$file);
				    	if(file_exists($album_location.'/'.$file.'/_thumbs/_'.$image['0'])) {
			        		echo "<img src=\"$album_location/$file/_thumbs/_".$image['0']."\"/><br/>";
			        	} elseif(!is_file($album_location."/".$file."/".$image['0'])) {
			        		echo "<img src=\"./empty.png\" height=\"80\" width=\"80\" />";
			        	} else {
			        		echo "<img src=\"".$album_location."/".$file."/".$image['0']."\" height=\"80\" width=\"80\"/><br/>";
			        	}
				    	echo $file; ?>
		            </a>
			        <input type="hidden" value="" id="image_<?php echo $i;?>"/>
			    </div>
		<?php }
		} else { echo "<p style=\"text-align:center;\">".$ccms['lang']['album']['noalbums']."</p>"; } ?>
		</div>
		
		<div class="span-8">
			<h2><?php echo $ccms['lang']['album']['albumlist']; ?></h2>
			<form action="<?php echo $_SERVER['PHP_SELF'];?>?do=newalbum&amp;file=<?php echo $name;?>" name="newalbum" method="post" accept-charset="utf-8">
				<label for="album_name"><?php echo $ccms['lang']['album']['newalbum']; ?></label><input type="input" name="album_name" value="" class="large text" id="album_name">
				<p class="right"><input type="submit" value="<?php echo $ccms['lang']['forms']['createbutton']; ?>"></p>
			</form>
			<? if(!empty($albums)) { ?>
			<hr/>
			<table border="0" cellspacing="5" cellpadding="5">
				<tr>
					<th class="span-1"><span class="sprite error-icon">&#160;</span></th>
					<th class="span-4"><?php echo $ccms['lang']['album']['directory']; ?></th>
					<th class="span-4"><?php echo $ccms['lang']['album']['rename']; ?></th>
				</tr>
				<?php foreach ($albums as $i => $file) { 
					$isEven 	= !($i % 2);
					echo ($isEven!='1')?'<tr>':'<tr style="background-color: #E6F2D9;">';?>
						<form action="<?php echo $_SERVER['PHP_SELF'];?>?do=delalbum&amp;file=<?php echo $name;?>" name="delalbum_<?php echo $i;?>" method="post" accept-charset="utf-8">
							<td><input type="checkbox" onClick="confirmation('delalbum_<?php echo $i;?>')" name="albumname" value="<?php echo $file;?>"></td>
						</form>
						<td><?php echo $file;?> (5)</td>
						<form action="<?php echo $_SERVER['PHP_SELF'];?>?do=editalbum&amp;file=<?php echo $name;?>" name="editalbum_<?php echo $i;?>" method="post" accept-charset="utf-8">
							<td><input type="hidden" name="oldname" value="<?php echo $file;?>">
								<input type="input" class="text" style="width:100px;" name="newname" value="">&#160;
								<a href="javascript:document.editalbum_<?php echo $i;?>.submit();" title="<?php echo $ccms['lang']['album']['rename']." ".strtolower($ccms['lang']['album']['album']);?>" class="sprite edit"></a>
							</td>
						</form>
					</tr>
				<?php } ?>
			</table>
			<?php } ?>
		</div>
		<hr class="space"/>
		<p style="text-align:center;"><a href="backend.php?file=<?php echo $_GET['file'];?>"><?php echo $ccms['lang']['album']['refresh']; ?></a> | <a href="../../../<?php echo $name.".html";?>" class="external" target="_blank"><?php echo $ccms['lang']['backend']['previewpage']; ?></a></p>
	</body>
</html>
<?php } else die("No external access to file");?>