<?php
session_start();

/* ************************************************************
Copyright (C) 2008 - 2009 by Xander Groesbeek (CompactCMS.nl)
Revision:	CompactCMS - v 1.4.0
	
This file is part of CompactCMS.

CompactCMS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CompactCMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A reference to the original author of CompactCMS and its copyright
should be clearly visible AT ALL TIMES for the user of the back-
end. You are NOT allowed to remove any references to the original
author, communicating the product to be your own, without written
permission of the original copyright owner.

You should have received a copy of the GNU General Public License
along with CompactCMS. If not, see <http://www.gnu.org/licenses/>.
	
> Contact me for any inquiries.
> E: Xander@CompactCMS.nl
> W: http://community.CompactCMS.nl/forum
************************************************************ */

// Load basic configuration
require_once(dirname(__FILE__) . '/config.inc.php');

// LANGUAGE ==
// Either select the specified file ($cfg['language']) or fall back to English
$langfile = dirname(__FILE__) . '/languages/'.$cfg['language'].'.inc.php';
if(file_exists($langfile)) {
	require_once($langfile); 
} else {
	require_once(dirname(__FILE__) . '/languages/en.inc.php');
}

// SECURITY ==
// Include security file only for administration directory
$location = explode("/", $_SERVER['PHP_SELF']);
if(in_array("admin",$location)) {
	require_once(dirname(dirname(__FILE__)) . '/admin/includes/security.inc.php');
}

// DATABASE ==
// All set! Now this statement will connect to the database
$link 		= @mysql_connect($cfg['db_host'], $cfg['db_user'], $cfg['db_pass']);
			  @mysql_select_db($cfg['db_name'], $link); 
			  
			// Throw error when e.g. credentials are incorrect
			if (!$link && !is_resource($link)) {
				die($ccms['lang']['system']['error_database']);
			}
			
// ENVIRONMENT ==
// Some variables to help this file orientate on its environment
$current	= basename($_SERVER['REQUEST_URI']);
$curr_page	= isset($_GET['page']) ? mysql_real_escape_string($_GET['page']) : null;

// This files' current version 
$v = "1.4.0";

// TEMPLATES ==
// Read and list the available templates
if ($handle = @opendir(dirname(__FILE__) . '/templates/')) {
    while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != ".." && strpos($file, ".tpl.html")) {
			// Add the templates to an array for use through-out CCMS, while removing the extension .tpl.html (=9)
        	$template[] = substr($file,0,-9);
        }
    }
    closedir($handle);
} else {die($ccms['lang']['system']['error_templatedir']);}

// OPERATION MODE ==
// 1) Start normal operation mode (if sitemap.php is not requested directly).
// This will fill all variables based on the requested page, or throw a 403/404 error when applicable.
$pagereq = (!empty($_GET['page']))?$_GET['page']:null;
if($current != "sitemap.php" && $current != "sitemap.xml" && $pagereq != "sitemap") {
	if(!empty($_GET['page'])) {
		$result		= mysql_query("SELECT * FROM `pages` WHERE `urlpage` = '$curr_page'", $link);
	} elseif(empty($_GET['page'])) {
		$result		= mysql_query("SELECT * FROM `pages` WHERE `urlpage` = '".$cfg['homepage']."'", $link);
	}

	// Start switch for pages, select all the right details
	if(mysql_num_rows($result) != "0") {
	$row = mysql_fetch_assoc($result);
		$ccms['language']	= $cfg['language'];
		$ccms['sitename'] 	= $cfg['sitename'];
		$ccms['urlpage']	= $row['urlpage'];
		$ccms['pagetitle'] 	= $row['pagetitle'];
		$ccms['subheader'] 	= $row['subheader'];
		$ccms['desc']		= $row['description'];
		$ccms['keywords']	= $row['keywords'];
		$ccms['title'] 		= ucfirst($ccms['pagetitle'])." - ".$ccms['sitename']." | ".$ccms['subheader'];
		$ccms['printable']	= $row['printable'];
		
		// Internal reference
		$ccms['published']	= $row['published'];
		$ccms['iscoding']	= $row['iscoding'];
		
		function ccmsContent() {
			global $ccms, $cfg;
			if($ccms['published']=='Y') {
				include_once(dirname(dirname(__FILE__)). "/content/".$ccms['urlpage'].".php");
			} elseif($ccms['published']=='N') {
				include_once(dirname(dirname(__FILE__)). "/content/403.php");
			}
		}
		
		
		// Set the template variable for current page
		$templatefile = dirname(__FILE__) . '/templates/'.$row['variant'].'.tpl.html';
		
		// Check whether template exists, specify default or throw "no templates" error.
		if(file_exists($templatefile)) {
			$ccms['template'] = $row['variant'];
		} elseif(count($template)!="0") {
			$ccms['template'] = $template['0'];
		} elseif(count($template)=="0") {
			echo $ccms['lang']['system']['error_notemplate'];
			exit();
		}
		
		// Create breadcrumb for the current page
		$ccms['breadcrumb'] 	= "<span class=\"breadcrumb\">&raquo; <a href=\"./\" title=\"".ucfirst($cfg['sitename'])." ".$cfg['homepage']."\">".ucfirst($cfg['homepage'])."</a>";
		if($row['toplevel']!=1 && $row['sublevel']==0) {
			$ccms['breadcrumb'] .= " &raquo; <a href=\"".$row['urlpage'].".html\" title=\"".$row['subheader']."\">".$row['pagetitle']."</a>";
		}
		if($row['sublevel']!=0) {
			$subpath = mysql_fetch_row(mysql_query("SELECT * FROM `pages` WHERE `toplevel` = '".$row['toplevel']."' AND `sublevel`='0'", $link));
			$ccms['breadcrumb'] .= " &raquo; <a href=\"".$subpath[1].".html\" title=\"".$subpath[8]."\">".$subpath[7]."</a> &raquo; <a href=\"".$row['urlpage'].".html\" title=\"".$row['subheader']."\">".$row['pagetitle']."</a>";
		}
		$ccms['breadcrumb']	.= "</span>";
	} 
	
	// ERROR 404
	// Or if DB query returns zero, show error 404: file does not exist
	elseif(mysql_num_rows($result) == "0") {
		$ccms['sitename'] 	= $cfg['sitename'];
		$ccms['pagetitle']	= $ccms['lang']['system']['error_404title'];
		$ccms['subheader']	= $ccms['lang']['system']['error_404header'];
		$ccms['title']		= ucfirst($ccms['pagetitle'])." - ".$ccms['sitename']." | ".$ccms['subheader'];
		function ccmsContent() { include_once(dirname(dirname(__FILE__)). "/content/404.php"); }
		$ccms['printable']	= "N";
		$ccms['published']	= "Y";
		$ccms['breadcrumb']	= "<span class=\"breadcrumb\">&raquo; <a href=\"./\" title=\"".ucfirst($cfg['sitename'])." ".$cfg['homepage']."\">".ucfirst($cfg['homepage'])."</a> &raquo ".$ccms['lang']['system']['error_404title'];
		
		if(count($template)!="0") {
			$ccms['template'] = $template['0'];
		} elseif(count($template)=="0") {
			echo $ccms['lang']['system']['error_notemplate'];
			exit();
		}
	}
}

// OPERATION MODE ==
// 2) Start dynamic sitemap creation used by spiders and various webmaster tools.
// e.g. You can use this function to submit a dynamic sitemap to Google Webmaster Tools.
elseif($current == "sitemap.php" || $current == "sitemap.xml") {
	$dir	= substr($_SERVER['SCRIPT_NAME'],0,-15);
	$result	= mysql_query("SELECT `urlpage` FROM `pages` WHERE `published` = 'Y'", $link);
		header ("content-type: text/xml");
		echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		?>
		<urlset
			xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
			xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9
	            http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
		<?php
		while ($row = mysql_fetch_assoc($result)):
	    	echo "<url>\n";
		if($row['urlpage'] == $cfg['homepage']) { 
			echo "<loc>http://".$_SERVER['SERVER_NAME']."".$dir."</loc>\n";
			echo "<priority>0.80</priority>\n";
		} else {
			echo "<loc>http://".$_SERVER['SERVER_NAME']."".$dir."".$row['urlpage'].".html</loc>\n";
			echo "<priority>0.50</priority>\n";
		}
			echo "<changefreq>weekly</changefreq>\n";
			echo "</url>\n";
		endwhile;
			echo "</urlset>";
} 

// OPERATION MODE ==
// 3) Start site structure generation to a default maximum of five ($i <= '5').
// Use the various menu item variables to get a dynamic structured list (ul). Current item marked with class="current".
for ($i = 1; $i <= '5'; $i++) { 
	$map_result = mysql_query("SELECT * FROM `pages` WHERE `published` = 'Y' AND `toplevel` != '125' AND `menu_id` = '$i' ORDER BY `toplevel` ASC", $link);
	// Start structuring
	$ccms['structure'.$i] = "<ul>";
	
	while ($row = mysql_fetch_assoc($map_result)):
		if($row['sublevel']=="0") {
			$istop = ($row['urlpage']==$curr_page)?'class="current"':null;
			$extop = (preg_match('/^(http(s?):\/\/{1})((\w+\.){1,})\w{2,}(\/?)$/i', $row['description']))?true:false;
			if($row['islink']=="N") {
				$ccms['structure'.$i] .= "<li><a $istop href=\"#\" title=\"".ucfirst($row['subheader'])."\">".ucfirst($row['pagetitle'])."</a>";
			} elseif($row['islink']=="Y" && $row['urlpage']!=$cfg['homepage'] && $extop===false) {
				$ccms['structure'.$i] .= "<li><a $istop href=\"".$row['urlpage'].".html\" title=\"".ucfirst($row['subheader'])."\">".ucfirst($row['pagetitle'])."</a>";
			} elseif($row['islink']=="Y" && $row['urlpage']!=$cfg['homepage'] && $extop===true) {
				$ccms['structure'.$i] .= "<li><a $istop href=\"".$row['description']."\" title=\"".ucfirst($row['subheader'])."\">".ucfirst($row['pagetitle'])."</a>";
			} elseif($row['islink']=="Y" && $row['urlpage']==$cfg['homepage']) {
				$istop = (!isset($curr_page))?'class="current"':null;
				$ccms['structure'.$i] .= "<li><a $istop href=\"./\" title=\"".ucfirst($row['subheader'])."\">".ucfirst($row['pagetitle'])."</a>";
			}
			
			$sub_result = mysql_query("SELECT * FROM `pages` WHERE `toplevel` = '".$row['toplevel']."' AND `sublevel`!='0' AND `menu_id` = '$i' AND `islink` = 'Y' ORDER BY `sublevel` ASC", $link);
			if(mysql_num_rows($sub_result)>"0") {
				$ccms['structure'.$i] .= "<ul class=\"sublevel\">";
				while ($sub = mysql_fetch_assoc($sub_result)):
					$issub = ($sub['urlpage']==$curr_page)?'class="current"':null;
					$exsub = (preg_match('/^(http(s?):\/\/{1})((\w+\.){1,})\w{2,}(\/?)$/i', $sub['description']))?true:false;
					if($exsub===false) { 
						$ccms['structure'.$i] .= "<li><a $issub href=\"".$sub['urlpage'].".html\" title=\"".ucfirst($sub['subheader'])."\">".ucfirst($sub['pagetitle'])."</a></li>";
					} elseif($exsub===true) {
						$ccms['structure'.$i] .= "<li><a $issub href=\"".$sub['description']."\" title=\"".ucfirst($sub['subheader'])."\">".ucfirst($sub['pagetitle'])."</a></li>";
					}
				endwhile;
				$ccms['structure'.$i] .= "</ul></li>";
			} elseif(mysql_num_rows($sub_result)=="0") {
				$ccms['structure'.$i] .= "</li>";
			}
		}
	endwhile;
	$ccms['structure'.$i] .= "</ul>";
}
?>